openmat <- function(fun, rec) {
 #fun = 3 verify a batch 
 #rec = open database or recipe

 #choose and read db/recipe depending on rec-value
 #select materials
 #save information in vectors, like densities
 #prepare data frame 'preparation' with first column diameters 
 #  and then the selected material-CPFT's

 if (fun==3) { #Verify recipe
  error <- batch(Materials,preparation,densities,fun)
 } 
      
 return(error) #values: 0 quit, 1 main menu, 2 open recipe/database
} #end openmat-function


batch <- function (Materials,preparation,densities,fun) {
 while (TRUE) { #batch definition-loop
  
  #choose batch type-window (vol% or mass%)
  #tcl-variable cm, initialized with 0
  #cm <- 1 back to main menu, cm <- 2 back to material selection, 
  #cm <- 3 ma%, cm <- 4 vol%
  #wait till cm non-zero and assign to var:
  var <- tclvalue(cm)
  
  if (var < 3) { 
   return(var) #values: 0 quit, 1 main menu, 2 material selection
  } else if (var==3) { 
   #set ma% amounts: boundsMass
   #and calculate vol% amounts boundsVol with densities
  } else if (var==4) {
   #set vol% amounts boundsVol
   #and calculate ma% amounts boundsMass with densities
  }

  if (100*sum(boundsVol)!=100 || 100*sum(boundsMass)!=100) {
   #message that batch has to add up to 100%
   next #starting over with batch definition-loop
  }

  if (fun==3) {
   value <- modelver(Materials,preparation,densities,boundsMass,
   boundsVol)
  } 

  if (value < 3) { return(value) }
  #return values: 0 quit, 1 main menu, 2 material selection

 } #while loop bounds 
} #end batch-function


modelver <- function(Materials,preparation,densities,boundsMass,
boundsVol) {
 while (TRUE) {
   
  #choose model-window; tcl-variable cm (init 0)
  #cm <- 1 main menu, cm <- 2 material selection, cm <- 3 batch 
  #  definition, cm <- 4-10 the different models
  #wait till cm non-zero, then assign to var:
  var <- tclvalue(cm)
  
  if (var < 4) { return(var) }
  #return values: 1 back to main menu, 2 back to open recipe/
  #  database, 3 back to batch definition
  
  if (var == ...) {
   #define and calculate VolumeModel (as global variable)
  }
  
  valmod <- verify(Materials,preparation,densities,boundsMass,
  boundsVol)

  if (valmod < 4) { return(valmod) }
  #return values: 0 quit, 1 back to main menu, 2 back to open 
  #               recipe/database, 3 back to batch definition, 
  #               4 back to model selection
  
 } #while loop model selection 
} #end modelver-function


verify <- function (Materials,preparation,densities,boundsMass,
boundsVol) {
 #add Volume Model to preparation data frame
 #save preparation in tuning
 #calculate batch density

 while (TRUE) {
  #show results-window; tcl-variable done <- 0
  #menu: save-operations
  #done <- 1 main menu, done <- 2 material selection, 
  #done <- 3 batch definition, 4 model selection
  #wait till done non-zero, assign to don:
  don <- tclvalue(done)

  if (don < 5) { return(don) }
  #return values: 0 quit, 1 back to main menu, 2 back to open 
  #               recipe/database, 3 back to batch definition, 
  #               4 back to model selection, 5 show results again  
 } #while loop results-window
} #end verify-function


#---MAIN WINDOW (no function)---
while (TRUE) { #main window while loop

 #init main window with tcl-variable app with start value 0
 #destroy event and 'Quit' menu bar button asign value 1 to app
 #functions asign other values, verify-function asigns value 3
 #the window is kept alive till app is non-zero, meaning, till 
 #  something to do was chosen by user
 #then the value of the tcl variable app is asigned to a common 
 #  variable var1:
 var1 <- tclvalue(app)

 if (var1 == 1) {
  #save options and settings
  break #get out of main window-loop == exit software
 } else if (...) { #other functions including database functions, 
                   #except of main functions 'design a batch', 
                   #'verify a batch' and 'calc. model parameters'
 } else { #main functions
  while (TRUE) { #open recipe/database window
   #open dtabase or recipe?
   #tcl-variable db initialized with 0
   #back to main db <- 1
   #open database or recipe db <- 2 or 3
   #wait for decision until db non-zero
   #then the value of db is asigned to a common variable var2:
   var2 <- tclvalue(db)
 
   if (var2 == 1) {
    appdb <- 1
    break #get out of open recipe/database-loop, meaning:
          #return to main menu
   }
    
   appdb <- openmat(fun=var1, rec=var2)
  
   if (appdb == 0) { break } #return to main menu and then exit
   if (appdb == 1) { break } #return to main menu
   
  } #while db vs recipe
 } #end else - main functions
 
 if (appdb == 0) {   
  #save options and settings   
  break #get out of main window-loop == exit software
 }
} #end while main window loop
